        (DEFUN C:MASKE ()
        (DEFUN EV ()    ; Unterprogramm Einlesen der Systemvariablen
                (SETQ CLAYERALT(GETVAR "CLAYER"))
                (SETVAR "MAXSORT" 400)
                (SETQ cmde (GETVAR "CMDECHO"))
                (SETVAR "CMDECHO" 0)
                (SETVAR "OSMODE" 0)
        )
;
        (DEFUN BW ()    ; Unterprogramm Bauweisen-Abfrage
(INITGET 1 "RL RQ DO DI")
(SETQ bw(GETKWORD "\nWelche Bauweise: Reihenlngs- (RL), Reihenquer- (RQ),\nDiagonal- (DI), Doppelstichbauweise (DO) ? "))
        (COND        
                ((= bw "RL") (ED))     ; ED: Unterprogramm Einfach-, DoppelSS-abfrage
                ((= bw "RQ") (ED))
                ((= bw "DI") (ED))
                ((= bw "DO") (DOH))     ;DOH: Doppelstich-H-Bauweise
        )
        )       ;Klammer Unterpr. Bauweise
;
        (DEFUN ED ()   ; Unterprogramm SS-Abfrage
(INITGET 1 "ESS DSS")
(SETQ ss(GETKWORD "\nEinfach- (ESS) oder Doppelsammelschiene (DSS) ? "))
        (COND
                ((= ss "ESS") (ESS))
                ((= ss "DSS") (DSS))
        )
        )       ; Klammer Unterpr. SS-Abfrage
;
        (DEFUN ESS ()   ; Unterprogramm EinfachSS
;
(SETQ a(GETREAL "\nPhasenabstand Sammelschiene, Ma a, smtliche Eingaben in m: "))
(SETQ a (* a 1000))
(SETQ f(GETREAL "\nFeldteilung, Ma f: "))
(SETQ f (* f 1000))
(SETQ g(GETREAL "\nFeldteilung Anfangsfeld, Ma g: "))
(SETQ g (* g 1000))
(SETQ h(GETREAL "\nPhasenabstand Abzweig, Ma h: "))
(SETQ h (* h 1000))
(SETQ k(GETREAL "\nAbstand SS-Mitte (Phase L2) - Freileitungsportal, Ma k: "))
(SETQ k (* k 1000))
(SETQ l(GETREAL "\nAbstand SS-Mitte (Phase L2) - Transformator, Ma l: "))
(SETQ l (* l 1000))
(SETQ anz(GETINT "\nAnzahl der Abzweige bis zum nchsten Gerst\n(bei RQ bis zur Symmetrielinie der Anlage): "))
;;(SETQ SPP(GETPOINT "\nStartpunkt SSI, Phase L2, links oben: "))
(SETQ SPP (LIST 6000 50000))
(SETQ SP(POLAR SPP (/ pi 2) a))
(SETQ SP1(POLAR SP (* 3 (/ pi 2)) (* 2 a )))
(SETQ P21(POLAR SP1 0 (+ g (* (- anz 1) f) g)))
(SETQ P1(POLAR SPP 0 g))
(SETQ P2(POLAR P21 (/ pi 2) (* a 2)))
(SETQ P5(POLAR P1 (/ pi 2) k))
(SETQ P6(POLAR P1 (* 3 (/ pi 2)) l))
(SETQ P51(POLAR P5 pi h))
(SETQ P61(POLAR P6 0 h))
(COMMAND "LAYER" "SE" "Hilfslinien" "")
(COMMAND "LINIE" SP1 P21 "")
(SETQ LD(SSGET "L"))
(COMMAND "REIHE" LD "" "R" "3" "1" a) 
(COMMAND "LAYER" "SE" "SKanten" "")
(COMMAND "LINIE" P5 P6 "")
(COMMAND "LAYER" "SE" "Hilfslinien" "")
(COMMAND "LINIE" P5 P6 "")
(COMMAND "VERSETZ" h P5 SP "")
(COMMAND "VERSETZ" h P5 P2 "")
(SETQ LB(SSGET "F" P51 P61))
(COMMAND "REIHE" LB "" "R" "1" anz f) 
(COMMAND "LAYER" "A" "SKanten" "")
      (PRINC)
        ); Klammer Unterprogramm ESS  
;
        (DEFUN DOH ()    ;Unterprogramm Doppelstich
;
(SETQ a(GETREAL "\nPhasenabstand Sammelschiene, Ma a, smtliche Eingaben in m: "))
(SETQ a (* a 1000))
(SETQ f(GETREAL "\nFeldteilung, Ma f: "))
(SETQ f (* f 1000))
(SETQ g(GETREAL "\nFeldteilung Anfangsfeld, Ma g: "))
(SETQ g (* g 1000))
(SETQ h(GETREAL "\nPhasenabstand Abzweig, Ma h: "))
(SETQ h (* h 1000))
(SETQ k(GETREAL "\nAbstand SS-Mitte (Phase L2) - Freileitungsportal, Ma k: "))
(SETQ k (* k 1000))
(SETQ l(GETREAL "\nAbstand SS-Mitte (Phase L2) - Transformator, Ma l: "))
(SETQ l (* l 1000))
;(SETQ SPP(GETPOINT "\nStartpunkt SSI, Phase L2, links oben: "))
(SETQ SPP (LIST 6000.0 50000.0 0.0))
(SETQ SP(POLAR SPP (/ pi 2) a))
(SETQ SP1(POLAR SP (* 3 (/ pi 2)) (* 2 a )))
(SETQ P21(POLAR SP1 0 (+ g f g)))
(SETQ P1(POLAR SPP 0 g))
(SETQ P2(POLAR P21 (/ pi 2) (* a 2)))
(SETQ P5(POLAR P1 (/ pi 2) k))
(SETQ P6(POLAR P1 (* 3 (/ pi 2)) l))
(SETQ P51(POLAR P5 pi h))
(SETQ P61(POLAR P6 0 h))
(COMMAND "LAYER" "SE" "Hilfslinien" "")
(COMMAND "LINIE" SP1 P21 "")
(SETQ LD(SSGET "L"))
(COMMAND "REIHE" LD "" "R" "3" "1" a) 
(COMMAND "LAYER" "SE" "SKanten" "")
(COMMAND "LINIE" P5 P6 "")
(COMMAND "LAYER" "SE" "Hilfslinien" "")
(COMMAND "LINIE" P5 P6 "")
(COMMAND "VERSETZ" h P5 SP "")
(COMMAND "VERSETZ" h P5 P2 "")
(SETQ LB(SSGET "F" P51 P61))
(COMMAND "REIHE" LB "" "R" "1" "2" f) 
(COMMAND "LAYER" "A" "SKanten" "")
      (PRINC)
   ); Klammer Unterprogramm DO       
;     
;
        (DEFUN DSS ()   ; Unterprogramm DoppelSS        
;
(SETQ a(GETREAL "\nPhasenabstand Sammelschiene, Ma a, smtliche Eingaben in m: "))
(SETQ a (* a 1000))
(SETQ b(GETREAL "\nAbstand SSI - SSII, Ma b: "))
(SETQ b (* b 1000))
(SETQ f(GETREAL "\nFeldteilung, Ma f: "))
(SETQ f (* f 1000))
(SETQ g(GETREAL "\nFeldteilung Anfangsfeld, Ma g: "))
(SETQ g (* g 1000))
(SETQ h(GETREAL "\nPhasenabstand Abzweig, Ma h: "))
(SETQ h (* h 1000))
(SETQ k(GETREAL "\nAbstand SS-Mitte - Freileitungsportal, Ma k: "))
(SETQ k (* k 1000))
(SETQ l(GETREAL "\nAbstand SS-Mitte - Transformator, Ma l: "))
(SETQ l (* l 1000))
(SETQ anzw 0)
(SETQ kuw "N")
(SETQ ku6w "N")
(PRINC "\nAnzahl der Abzweige bis zum zweiten Gerst")
(SETQ anz(GETINT "\noder bis zu einer Kupplung (Kupplungsabzweig nicht mitzhlen!): "))
(INITGET 1 "J N")
(SETQ ku(GETKWORD "\n10-Trenner-Kupplung in diesem Abschnitt vorhanden (J/N)?  "))
        (IF (= ku "N")
                (PROGN
(INITGET 1 "J N")
(SETQ ku6(GETKWORD "\n6-Trenner-Kupplung in diesem Abschnitt vorhanden (J/N)?  "))
                )
        (SETQ ku6 "N")
        )
        (COND ((and (= ku "N") (= ku6 "N"))
                     (PROGN
(PRINC "\nAnzahl der Abzweige zwischen dem zweiten und dritten Gerst")
(SETQ anzw(GETINT "\noder bis zu einer Kupplung (Kupplungsabzweig nicht mitzhlen!): "))
        (COND ((/= anzw 0) 
                (PROGN
(INITGET 1 "J N")
(SETQ kuw(GETKWORD "\n10-Trenner-Kupplung in diesem Abschnitt vorhanden (J/N)?  "))
        (IF (= kuw "N")
                (PROGN
(INITGET 1 "J N")
(SETQ ku6w(GETKWORD "\n6-Trenner-Kupplung in diesem Abschnitt vorhanden (J/N)?  "))
                )
        (SETQ ku6w "N")
        )
                ))
        )
                ))
                ((or (= ku "J") (= ku6 "J"))   
                        (PROGN
                        (SETQ kuw "N")
                        (SETQ ku6w "N")
                ))
        )
;(SETQ SPP(GETPOINT "\nStartpunkt SSI, Phase L2, links oben: "))
(SETQ SPP (LIST 6000 50000))
        (IF (= ku6 "J")
                (SETQ anz (+ anz 1))
        )        
        (IF (= ku "J")
                (SETQ ksl (* 2 g))
                (SETQ ksl 0)
        )
(SETQ SP(POLAR SPP (/ pi 2) a))
(SETQ SP1(POLAR SP (* 3 (/ pi 2)) (* 2 a )))
(SETQ P21(POLAR SP1 0 (+ g (* (- anz 1) f) g ksl)))
(SETQ P2(POLAR P21 (/ pi 2) (* a 2)))
(SETQ P3(POLAR SP (* 3 (/ pi 2)) (+ a (/ b 2))))
(SETQ P31(POLAR P3 0 500))
(SETQ P32(POLAR P3 (/ pi 2) 500))
(SETQ P34(POLAR P3 (* 3 (/ pi 2)) 500))
(SETQ P33(POLAR P3 pi 500))
(SETQ P4(POLAR P3 0 g))
(SETQ P5(POLAR P4 (/ pi 2) k))
(SETQ P6(POLAR P4 (* 3 (/ pi 2)) l))
(SETQ P51(POLAR P5 pi h))
(SETQ P61(POLAR P6 0 h))
(SETQ P7(POLAR P21 pi (* 2 g)))
(COMMAND "LAYER" "SE" "Hilfslinien" "")
(COMMAND "LINIE" SP1 P21 "")
(SETQ LD(SSGET "L"))
(COMMAND "REIHE" LD "" "R" "3" "1" a) 
(SETQ LA(SSGET "F" SP1 P2))                
(COMMAND "SPIEGELN" LA ""  P3 P4 "") 
(COMMAND "LAYER" "SE" "SKanten" "")
(COMMAND "LINIE" P5 P6 "")
(COMMAND "LAYER" "SE" "Hilfslinien" "")
(COMMAND "LINIE" P5 P6 "")
(COMMAND "VERSETZ" h P5 SP "")
(COMMAND "VERSETZ" h P5 P2 "")
(SETQ LB(SSGET "F" P51 P61))
(COMMAND "REIHE" LB "" "R" "1" anz f) 
        (IF (= ku "J")
                (PROGN
                (COMMAND "KOPIEREN" LB "" SP1 P7) 
                (SETQ P8(POLAR P7 (/ pi 2) (* 2 a)))
                (COMMAND "LINIE" P7 P8 "")
                (SETQ A1(SSGET "L"))
                (COMMAND "SPIEGELN" A1 ""  P3 P4 "")
                )
        )
(COMMAND "LAYER" "A" "SKanten" "")
;       Mittelachse
(COMMAND "LINIE" P32 P34 "")
(COMMAND "LINIE" P33 P31 "")
;
        (IF (/= anzw 0)
                (PROGN

(SETQ SPPW(POLAR P21 (/ pi 2) a))
        (IF (= ku6w "J")
                (SETQ anzw (+ anzw 1))
        )        
        (IF (= kuw "J")
                (SETQ kslw (* 2 g))
                (SETQ kslw 0)
        )
(SETQ SPW(POLAR SPPW (/ pi 2) a))
(SETQ SP1W(POLAR SPW (* 3 (/ pi 2)) (* 2 a )))
(SETQ P21W(POLAR SP1W 0 (+ g (* (- anzw 1) f) g kslw)))
;(SETQ P1W(POLAR SPW 0 (+ g f (/ f 2))))
(SETQ P2W(POLAR P21W (/ pi 2) (* a 2)))
(SETQ P3W(POLAR SPW (* 3 (/ pi 2)) (+ a (/ b 2))))
(SETQ P4W(POLAR P3W 0 g))
(SETQ P5W(POLAR P4W (/ pi 2) k))
(SETQ P6W(POLAR P4W (* 3 (/ pi 2)) l))
(SETQ P7W(POLAR P6W 0 f))
(SETQ P51W(POLAR P5W pi h))
(SETQ P61W(POLAR P6W 0 h))
(SETQ P7W(POLAR P21W pi (* 2 g)))
(COMMAND "LINIE" SP1W P21W "")
(SETQ LDW(SSGET "L"))
(COMMAND "REIHE" LDW "" "R" "3" "1" a) 
(SETQ LAW(SSGET "F" SP1W P2W))                
(COMMAND "SPIEGELN" LAW ""  P3W P4W "") 
(COMMAND "LAYER" "SE" "SKanten" "")
(COMMAND "LINIE" P5W P6W "")
(COMMAND "LAYER" "SE" "Hilfslinien" "")
(COMMAND "LINIE" P5W P6W "")
(COMMAND "VERSETZ" h P5W SPW "")
(COMMAND "VERSETZ" h P5W P2W "")
(SETQ LBW(SSGET "F" P51W P61W))
        (IF (/= anzw 1)
(COMMAND "REIHE" LBW "" "R" "1" anzw f) 
        )
        (IF (= kuw "J")
                (PROGN
                (COMMAND "KOPIEREN" LBW "" SP1W P7W) 
                (SETQ P8W(POLAR P7W (/ pi 2) (* 2 a)))
                (COMMAND "LINIE" P7W P8W "")
                (SETQ A1W(SSGET "L"))
                (COMMAND "SPIEGELN" A1W ""  P3W P4W "")
                )
        )
(COMMAND "LAYER" "A" "SKanten" "")
    ) ;PROGN
  )       ; if anz
        (PRINC)
        ); Klammer Unterprogramm DSS
;
        (DEFUN RSV ()   ;Unterprogramm Rcksetzen der Variablen
                (COMMAND "LAYER" "SE" CLAYERALT "")
                (PRINC)
                (SETVAR "CMDECHO" cmde)
        )
;
;Hauptprogramm 
        (EV)
        (BW)
        (RSV)
        (PRINC)
)        ; Klammer Defun C:
;
;
;
(DEFUN C:GRUBE()        ;lgrube fr Trafos und Drosseln
        (SETQ CLAYERALT(GETVAR "CLAYER"))
        (SETQ cmde (GETVAR "CMDECHO"))
        (SETVAR "CMDECHO" 0)
        (setq OSALT (GETVAR "OSMODE"))
(setvar "osmode" 0)
(setq w0 0)
(setq w90(/ pi 2))
(setq w180 pi)
(setq w270(* 1.5 pi))                                     
(setq p1(getpoint "\nLinker unterer Transformator-Eckpunkt (Kessel bzw. Ausdehnungsgef): "))
(setq p2(getpoint "\nRechter oberer Transformator-Eckpunkt (Kessel bzw. Ausdehnungsgef): "))
(setvar "osmode" 32)
(setq m(getpoint "\nSchnittpunkt Transformatorsymmetrielinien: "))
(setq ml2 (getpoint "\nSchnittpunkt Transformatorsymmetrielinie - Phase L2: "))
(setvar "osmode" 0)
;
;Grundrisslayer Ausschalten, Schnittlayer Einschalten
       (COMMAND "LAYER" "SE" "0" "A" "KANTEN" "A" "VERDECKT" "A"
       "SCHMAL" "A" "MITTEL" "A" "SCHRAFFUR" "EI" "SKANTEN" "EI"
       "SVERDECKT" "EI" "SSCHMAL" "EI" "SMITTEL" "EI" "SSCHRAFFUR" 
       "SE" "SKANTEN" "")
(PRINC)
;Ende
(setq p3(getpoint "\nUntere Transformatorkesselkante (bzw. Bodenniveau): "))
(setq p4(getpoint "\nObere Transformatorkesselkante: "))
;
;Schnittlayer Ausschalten, Grundrisslayer Einschalten
        (COMMAND "LAYER" "SE" "0" "A" "SKANTEN" "A" "SVERDECKT" "A"
         "SSCHMAL" "A" "SMITTEL" "A" "SSCHRAFFUR" "EI" "KANTEN" "EI"
         "VERDECKT" "EI" "SCHMAL" "EI" "MITTEL" "EI" "SCHRAFFUR" "SE" "KANTEN" "")
(PRINC)
;Ende
;
(setq pe(polar p1 w0 (- (car p2) (car p1))))
(setq L(+ (distance pe p1) (* 0.4 (distance p4 p3))))
(setq B(+ (distance p2 pe) (* 0.4 (distance p4 p3))))

(setq sph(polar m w180 (/ L 2)))
(setq sp(polar sph w270 (/ B 2)))

(setq fr1(getpoint "\nAusfahrrichtung von ..."))
(setq fr2(getpoint "\nnach ..."))
(if (< (abs (- (cadr fr1) (cadr fr2))) (abs (- (car fr1) (car fr2))))
 (progn
  (if (< B L) 
   (setq s 1500) 
   (progn
    (initget 1 "T D")
    (setq atd(getkword "\n Transformator oder Drossel? (T/D): "))
    (if (= atd "T") (setq s 3000))
    (if (= atd "D") (setq s 2000))
   )             
   )

 (tragruv)
 ) 
 (progn
   
   (setq sph(polar m w0 (/ L 2)))
   (setq sp(polar sph w270 (/ B 2)))
   
   (setq w180(* 1.5 pi))
   (setq w270 0)
   (setq w0(/ pi 2))
   (setq w90 pi)
   (setq BH B)
   (setq B L)
   (setq L BH)
   (setq e1(polar sp w0 L))
   (setq e2(polar e1 w90 B))
   (setq e3(polar e2 w180 L))
  (if (< B L) 
   (setq s 1500) 
   (progn
    (initget 1 "T D")
    (setq atd(getkword "\n Transformator oder Drossel? (T/D): "))
    (if (= atd "T") (setq s 3000))
    (if (= atd "D") (setq s 2000))
   )             
   )

   (tragrus)
))
  (setq e1(polar sp w0 L))
  (setq e2(polar e1 w90 B))
  (setq e3(polar e2 w180 L))
  (command "layer" "se" "kanten" "")
 
 
  (setq sphh(polar sp w90 300))
  (setq e4(polar sphh w0 300))
  (setq e5(polar e4 w0 (- L 600)))
  (setq e6(polar e5 w90 (/ (- B (+ S 1000)) 2)))
  (setq e7(polar e6 w180 (- L 600)))
 
  (setq e8(polar e4 w90 (- B 600)))
  (setq e9(polar e8 w0 (- L 600)))
  (setq e10(polar e9 w270 (/ (- B (+ S 1000)) 2)))
  (setq e11(polar e10 w180 (- L 600)))
    
  (setq e12(polar e7 w90 400))
  (setq e13(polar e12 w0 (- L 600)))
  (setq e14(polar e13 w90 (- S 400)))
  (setq e15(polar e14 w180 (- L 600)))
  
  (setq e16(polar sp w90 (/ (- B (+ S 100)) 2)))
  (command "layer" "se" "kanten" "")
  (command "linie" e16 (polar e16 w0 L) "")
  (command "_copy" "l" "" e16 (polar e16 w90 100))
  (command "_copy" "l" "" e16 (polar e16 w90 S ))
  (command "_copy" "l" "" e16 (polar e16 w270 100))
  
;  (command "layer" "se" "mittel" "")
;  (command "linie" mpl mpr "")
  (command "layer" "se" "kanten" "")
  (command "linie" e4 e5 e6 e7 "s")
  (command "linie" e8 e9 e10 e11 "s")
  (command "linie" e12 e13 e14 e15 "s")
  (command "linie" sp e1 e2 e3 "s")
        (COMMAND "LAYER" "SE" CLAYERALT "")
(PRINC)
  (SETVAR "CMDECHO" cmde)
  (setvar "osmode" osalt)
(princ)
)
;
 (defun tragruv()
(setq t (* B 0.4))                 ; Tiefe  
(setq lv B)                               ;Lnge
;(setq s (getreal "\n Fundamentabstand :" ))
(setq p1v (polar ml2 (/ pi 2) (/ lv 2)))                       ;Startpunkt
(setq p2v(polar p1v pi t ))
(setq p3v (polar p2v ( * 3 ( / pi 2 )) lv ))
(setq p4v (polar p3v 0 t ))
(setq p5(polar p4v ( / pi 2) 300 ))
(setq p6(polar p5 pi 700 ))
(setq p7(polar p6 ( / pi 2) 200 ))
(setq p8(polar p7 pi (- t 1400 )))
(setq p9(polar p8 ( / pi 2 ) ( / ( - lv s 1800 ) 2 )))
(setq p10(polar p9 0 ( - t 1400 )))
(setq p11(polar p10 ( / pi 2 ) 200 ))
(setq p12(polar p11 0 700 ))
(setq p13(polar p12 ( / pi 2 ) 400 ))
(setq p14(polar p13 pi 700 ))
(setq p15(polar p14 ( / pi 2 ) 200 ))
(setq p16(polar p15 pi ( - t 1400 )))
(setq p17(polar p16 ( / pi 2 ) ( - s 800 )))
(setq p18(polar p17 0 ( - t 1400 )))
(setq p19(polar p18 ( / pi 2 ) 200 ))
(setq p20(polar p19 0 700 ))
(setq p21(polar p20 ( / pi 2) 400 ))
(setq p22(polar p21 pi 700 ))
(setq p23(polar p22 ( / pi 2 ) 200 ))
(setq p24(polar p23 pi ( - t 1400 )))
(setq p25(polar p24 ( / pi 2 ) ( / (- lv s 1800 ) 2 )))
(setq p26(polar p25 0 (- t 1400 )))
(setq p27(polar p26 ( / pi 2 ) 200 ))
(setq p28(polar p27 0 700 ))                  
(setq p5a(polar p5 pi 600))
(setq p5c(polar p5a 2.35 50))
(setq p12a(polar p12 pi 600))
(setq p13a(polar p13 pi 600))
(setq p13c(polar p13a 2.35 50))
(setq p20a(polar p20 pi 600))
(setq p21a(polar p21 pi 600))
(setq p21c(polar p21a 2.35 50))
(setq p28a(polar p28 pi 600))
(setq p5b(polar p5 pi 300))
(setq p5d(polar p5b 2.35 50))
(setq p12b(polar p12 pi 300))
(setq p13b(polar p13 pi 300))
(setq p13d(polar p13b 2.35 50))
(setq p20b(polar p20 pi 300))
(setq p21b(polar p21 pi 300))
(setq p21d(polar p21b 2.35 50))
(setq p28b(polar p28 pi 300))
;Grundrisslayer Ausschalten, Schnittlayer Einschalten
       (COMMAND "LAYER" "SE" "0" "A" "KANTEN" "A" "VERDECKT" "A"
       "SCHMAL" "A" "MITTEL" "A" "SCHRAFFUR" "A" "hilfslinien" "EI" "SKANTEN" "EI"
       "SVERDECKT" "EI" "SSCHMAL"  "EI" "SSCHRAFFUR" 
       "SE" "SKANTEN" "")
(PRINC)

(command "Layer" "se" "SKanten" "")
(command "Linie" p1v p2v p3v p4v p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 p17 
 p18 p19 p20 p21 p22 p23 p24 p25 p26 p27 p28 p1v "")
(command "Linie" p4v p1v "")
(command "Layer" "se" "sschmal" "")  
(command "Linie" p5a p12a "")
(command "Linie" p13a p20a "")
(command "Linie" p21a p28a "")
(command "Linie" p5b  p12b "")
(command "Linie" p13b p20b "")
(command "Linie" p21b p28b "")

(command "Linie" p7 p10 "")
(command "Linie" p15 p18 "")
(command "Linie" p23 p26 "")
(command "Layer" "se" "sschraffur" "")  
(setvar "HPNAME" "hex" )
(setvar "HPANG" 0 )
(setvar "HPSCALE" 250 )
(C:gschraff p5d)
(C:gschraff p13d)   
(C:gschraff p21d)   
(command "neuzeich")
(setvar "HPNAME" "brick" )
(setvar "HPANG" 0 )
(setvar "HPSCALE" 500 )
; ss1 (entlast)
(C:gschraff p5c)
(C:gschraff p13c)    
(C:gschraff p21c)    
;Schnittlayer Ausschalten, Grundrisslayer Einschalten
        (COMMAND "LAYER" "SE" "0" "A" "SKANTEN" "A" "SVERDECKT" "A"
         "SSCHMAL" "A" "SMITTEL" "A" "SSCHRAFFUR" "EI" "KANTEN" "EI" "hilfslinien"
         "EI" "VERDECKT" "EI" "SCHMAL" "EI" "MITTEL" "EI" "SCHRAFFUR" "SE" "KANTEN" "")
(PRINC)

(command "neuzeich")

)

(defun tragrus()
(setq t (* L 0.4))                ;Tiefe 
(setq lv L)       ;Lnge 
(setq sps (polar ml2 (/ pi 2) (/ lv 2)))      ;Startpunkt
(setq p1s(polar sps pi t ))
(setq p2s(polar p1s ( * 3 ( / pi 2 )) lv ))
(setq p3s(polar p2s 0 t ))
(setq p4s(polar p3s ( / pi 2 ) 300 ))
(setq p5(polar p4s pi 700 ))
(setq p6(polar p5 ( / pi 2 ) 200 ))
(setq p7(polar p6 pi ( - t 700 800 )))
(setq p13(polar sps ( * 3 ( / pi 2)) 300 ))
(setq p12(polar p13 pi 700 ))
(setq p11(polar p12 ( * 3 ( / pi 2)) 200 ))
(setq p10(polar p11 pi (- t 1000 )))
(setq p9 (polar p10 ( * 3 ( / pi 2)) 500 ))
(setq p8 (polar p9 0 300 ))
(setq p12a (polar p12 0 100 ))
(setq p5a  (polar p5  0 100 ))
(setq p12b (polar p12a 0 300 ))
(setq p12c (polar p12b 4.36 100 ))
(setq p12d (polar p12a 4.36 200  ))
(setq p5b  (polar p5a 0 300 ))
;Grundrisslayer Ausschalten, Schnittlayer Einschalten
       (COMMAND "LAYER" "SE" "0" "A" "KANTEN" "A" "VERDECKT" "A"
       "SCHMAL" "A" "MITTEL" "A" "SCHRAFFUR" "A" "hilfslinien" "EI" "SKANTEN" "EI"
       "SVERDECKT" "EI" "SSCHMAL"  "EI" "SSCHRAFFUR" 
       "SE" "SKANTEN" "")
(PRINC)

(command "Layer" "se" "SKanten" "")
(command "Linie" sps p1s p2s p3s p4s p5 p6 p7 "" )
(command "Linie" sps p13 p12 p11 p10 p9 p8 p7 ""  )
(command "Layer" "se" "sschmal" "")
(command "linie" p6 p11 "")
(command "Linie" p12a p5a "")
(command "Layer" "se" "SKanten" "")
(command "Linie" p13 p4s "")
(command "Layer" "se" "sschmal" "")
(command "Linie" p12b p5b "")
(command "Layer" "se" "sschraffur" "")
(setvar "HPNAME" "hex" )
(setvar "HPANG" 0 )
(setvar "HPSCALE" 250 )
; ss1 (entlast)
(C:gschraff p12c)                     
(command "neuzeich")
(setvar "HPNAME" "brick" )
(setvar "HPANG" 0 )
(setvar "HPSCALE" 500 )
; ss1 (entlast)
(C:gschraff p12d)
(command "neuzeich")
;Schnittlayer Ausschalten, Grundrisslayer Einschalten
        (COMMAND "LAYER" "SE" "0" "A" "SKANTEN" "A" "SVERDECKT" "A"
         "SSCHMAL" "A" "SMITTEL" "A" "SSCHRAFFUR" "EI" "KANTEN" "EI" "hilfslinien" "EI" 
         "VERDECKT" "EI" "SCHMAL" "EI" "MITTEL" "EI" "SCHRAFFUR" "SE" "KANTEN" "")
(PRINC)

)                 



;
(defun c:SEILH()        ;Seilverbindung horizontal
                        ;Parabel aus zwei Kurvenpunkten
                (SETQ cmde (GETVAR "CMDECHO"))
                (SETVAR "CMDECHO" 0)
(princ "\nObjektfangmodus ENDPUNKT ist eingeschaltet!")
(terpri)
(setvar "osmode" 1)
(setq P1 (getpoint "\nLinker Aufhngepunkt: "))
(setq P2 (getpoint "\nRechter Aufhngepunkt: "))
(princ)
(princ "\nObjektfangmodus ENDPUNKT ist wieder ausgeschaltet!") 
(setvar "osmode" 0)
(princ)
        (if (< (car P2) (car P1))
                (progn 
                        (terpri)
                        (prompt "Linken Aufhngepunkt zuerst anklicken!")
                        (princ)
                )
        )
(setq b(cadr P1))
(setq d(cadr P2))
(setq f(* (distance P1 P2) 0.02))
(setq a(car P1))
(setq c(car P2))
(setq P3x (car P1))
(setq P4x (car P2))
(setq P3y (- (/ (+ b d) 2) (* 2 f)))
(setq P4y P3y)
(setq P3(LIST P3x P3y))
(setq P4(list P4x P4y))
;
(setq S(inters P1 P4 P2 P3 ))
        (if (= S nil)
                (progn
                        (terpri)
                        (prompt "Befehl SEILV verwenden!")
                        (princ)
                )
                (progn
  (IF (SETQ xlay (TBLSEARCH "LAYER" "SSEIL"))
        (IF (OR (= (CDR (ASSOC '70 xlay)) 65)
                (MINUSP (CDR (ASSOC '62 xlay)))
             )
             (COMMAND "LAYER" "T" "SSEIL" "EI" "SSEIL" "")
        )
        (COMMAND "LAYER" "N" "SSEIL" "FA" "CYAN" "SSEIL" "")
  )
(COMMAND "LAYER" "SE" "SSEIL" "")
; SEILH verwendet Modul SEILV:
; SEILV : Parabel Seilverbindung vertikal, rechter Parabelast
       (SETQ bm (LIST 0 0))
       (SETQ u s)       ;unterer Anschlupunkt 
       (TERPRI)
       (SETQ o P2)         ;oberer Anschlupunkt  
       (TERPRI)
       (SETQ t 10)
       ;
       (SETQ so (POLAR u (/ PI 2) 50))
       ;
        (SETQ ff (- (ANGLE u so) (ANGLE u o)))
       ;
       (SETQ xu (CAR u))
       (SETQ yu (CADR u))
       ;
       (SETQ xo (* (DISTANCE u o) (SIN ff)))
       ;
       (SETQ i (/ xo t))
       ;
       (SETQ j (/ (COS ff) (SIN ff) xo))
       ;
       (SETQ x1 0)
       (SETQ y1 0)
       (WHILE
          (<= (+ x1 i) xo )
          ;
          (SETQ x2 (+ x1 i))
          (SETQ y2 (* j x2 x2))
          (COMMAND "LINIE"
             (LIST (+ xu x1 )
                (+ yu y1 ))
             (LIST (+ xu x2 )
                (+ yu y2 ))
             "")
          (SETQ x1 x2)
          (SETQ y1 y2)
        )
       ;
          (COMMAND "LINIE"
             (LIST (+ xu x2 )
                (+ yu y2 )) o
             "")
          (PRINC)
       ;linker Parabelast
       (SETQ bm (LIST 0 0))
       (SETQ u s)       ;unterer Anschlupunkt  
       (TERPRI)
       (SETQ o P1)         ;oberer Anschlupunkt
       (TERPRI)
       (SETQ t 10)
       ;
       (SETQ so (POLAR u (/ PI 2) 50))
       ;
        (SETQ ff (- (ANGLE u o) (ANGLE u so)))
       ;
       (SETQ xu (CAR u))
       (SETQ yu (CADR u))
       ;
       (SETQ xo (* (DISTANCE u o) (SIN ff)))
       ;
       (SETQ i (/ xo t))
       ;
       (SETQ j (/ (COS ff) (SIN ff) xo))
       ;
       (SETQ x1 0)
       (SETQ y1 0)
       (WHILE
             (<= (+ (abs x1) i) xo )
          (SETQ x2 (- x1 i))
          (SETQ y2 (* j x2 x2))
          (COMMAND "LINIE"
             (LIST (+ xu x1 )
                (+ yu y1 ))
             (LIST (+ xu x2 )
                (+ yu y2 ))
             "")
          (SETQ x1 x2)
          (SETQ y1 y2)
        )
          (COMMAND "LINIE"
             (LIST (+ xu x2 )
                (+ yu y2 ))  o
             "")
               (COMMAND "NEUZEICH")
        (PRINC)
                )       ; Klammer Progn
       )                ; Klammer IF
       (SETVAR "CMDECHO" cmde)
       (PRINC)
)
;
       (DEFUN C:SEILV ()   ; SEILV : Parabel Seilverbindung vertikal
                (SETQ cmde (GETVAR "CMDECHO"))
                (SETVAR "CMDECHO" 0)
        (PRINC "\nObjektfangmodus ENDPUNKT ist eingeschaltet!")
        (PRINC)
        (SETVAR "osmode" 1)
       (SETQ a (GETPOINT "\nunterer Anschlupunkt: "))
       (PRINC)
       (SETQ b (GETPOINT "\noberer Anschlupunkt: "))
       (PRINC) 
       (PRINC "\nObjektfangmodus ENDPUNKT ist wieder ausgeschaltet!  ")
       (SETVAR "osmode" 0)       
       (PRINC)
  (IF (SETQ xlay (TBLSEARCH "LAYER" "SSEIL"))
        (IF (OR (= (CDR (ASSOC '70 xlay)) 65)
                (MINUSP (CDR (ASSOC '62 xlay)))
             )
             (COMMAND "LAYER" "T" "SSEIL" "EI" "SSEIL" "")
        )
        (COMMAND "LAYER" "N" "SSEIL" "FA" "CYAN" "SSEIL" "")
  )
(COMMAND "LAYER" "SE" "SSEIL" "")
;
        (IF (= (CAR a) (CAR b))
                (progn
                (prompt "\nunterer und oberer Anschlupunkt liegen senkrecht bereinander!  ")
                (princ)
                )
                (progn
       (SETQ d 10)
       ;(TERPRI)
        ;
       (SETQ c (POLAR a (/ PI 2) 5000))
       ;
       (IF (< (CAR a) (CAR b))
                (PROGN
        ;
        (SETQ f (- (ANGLE a c) (ANGLE a b)))
       ;
       (SETQ xa (CAR a))
       (SETQ ya (CADR a))
       ;                                  
       ;
       (SETQ xb (* (DISTANCE a b) (SIN f)))
       ;
       (SETQ i (/ xb d))
       ;
       (SETQ j (/ (COS f) (SIN f) xb))
       ;
       (SETQ x1 0)
       (SETQ y1 0)
       z=0
       (WHILE
          (<= (+ x1 i) xb )
          (SETQ x2 (+ x1 i))
          (SETQ y2 (* j x2 x2))
          (COMMAND "LINIE"
             (LIST (+ xa x1) (+ ya y1))
             (LIST (+ xa x2) (+ ya y2)) "")
          (SETQ x1 x2)
          (SETQ y1 y2)
        )                ;Klammer WHILE
          (COMMAND "LINIE"
         (LIST (+ xa x2) (+ ya y2)) b "")
        (PRINC)
                )       ; Klammer progn <
       
     (progn            ; wenn nicht a kleiner b
       ;linker Parabelast
       ;
        (SETQ f (- (ANGLE a b) (ANGLE a c)))
       ;
       (SETQ xa (CAR a))
       (SETQ ya (CADR a))
       ;
       (SETQ xb (* (DISTANCE a b) (SIN f)))
       ;
       (SETQ i (/ xb d))
       ;
       (SETQ j (/ (COS f) (SIN f) xb))
       ;
       (SETQ x1 0)
       (SETQ y1 0)
       (WHILE
             (<= (+ (abs x1) i) xb )
          (SETQ x2 (- x1 i))
          (SETQ y2 (* j x2 x2))
          (COMMAND "LINIE"
             (LIST (+ xa x1 )
                (+ ya y1 ))
             (LIST (+ xa x2 )
                (+ ya y2 ))
             "")
          (SETQ x1 x2)
          (SETQ y1 y2)
        )
          (COMMAND "LINIE"
             (LIST (+ xa x2 )
                (+ ya y2 )) b
             "")
             (PRINC)
                )       ; Klammer progn a nicht kleiner b
        )               ; Klammer IF <
                )       ; Klammer Progn
       )                ; Klammer IF =
        (COMMAND "NEUZEICH")
        (PRINC)
    (SETVAR "CMDECHO" cmde)
)
;
;Zeichnet Rohr- bzw. Schienenverbindungen
(Defun C:Rohr ()
                (SETQ cmde (GETVAR "CMDECHO"))
                (SETVAR "CMDECHO" 0)
  (Initget "2 A M K")
  (Setq B (Getkword "\nMittellinie/<Kante>: "))
  (If
    (= nil B)
      (Setq B "K")
  )
  (If
    (Or (= B "K") (= B "M"))
      (Progn
        (Prompt "\nDurchmesser des Rohres bzw. Breite der Schiene <")
        (Princ (Rtos (Getvar "Userr1") 2 3))
        (Initget 6)
        (Setq A (Getdist ">: "))
        (If
          (= nil A)
            (Setq A (Getvar "Userr1"))
        )
        (Setvar "Userr1" A)
      )
      (Progn
        (Initget 7)
        (Setq A1 (Getdist "\nErster Abstand: "))
        (Initget 7)
        (Setq A2 (Getdist "\nZweiter Abstand: "))
      )
  )
  (Initget 1)
  (Setq P1 (Getpoint "\nVon Punkt: "))
  (Initget 1)
  (Setq P2 (Getpoint P1 "\nNach Punkt: "))
  (Command "Plinie" P1 P2)
  (Setq P4 t)
  (While
    (Boundp 'P4)
      (Initget "Z S")
      (Setq P4 
        (Getpoint (Getvar "Lastpoint") "\nZurck/Schliessen/<Nach Punkt>: "))
      (Cond
        ((= nil P4)
          (Command "")
        )
        ((= "S" P4)
          (Command "Schliessen")
          (Setq P4 nil)
        )
        ((= "Z" P4)
          (Command "Zurck")
        )
        ((= 'LIST (Type P4))
          (Command P4)
        )
      )
  )
  (Cond
    ((= B "K")
      (Setq E2 (Entlast))
      (Setq P2 (Getpoint "\nAuf welcher Seite liegt das Rohr/Schiene?"))
      (Command "VERSETZ" A P1 P2 "")
      (Setq E3 (Entlast))
    )
    ((= B "M")
      (Setq E1 (Entlast))
      (Command "Wahl" "L" "")
      (Command "Versetz" (/ A 2)
        (Polar P1 (Angle P1 P2) (/ (Distance P1 P2) 2))
        (Polar (Getvar "Lastpoint") (+ (/ Pi 2) (Angle P1 P2)) (/ A 2)) "")
      (Setq E2 (Entlast))
      (Command "Versetz" A (Getvar "Lastpoint")
        (Polar (Getvar "Lastpoint") (+ (/ Pi 2) (Angle P2 P1)) A) "")
      (Setq E3 (Entlast))
    )
    ((or (= B "A") (= B "2"))
      (Setq E1 (Entlast))
      (Command "Wahl" "L" "")
      (Prompt "\nAuf welcher Seite soll ")
      (Princ (Rtos A1 2 4))
      (Setq P2 (Getpoint " abgetragen werden: "))
      (Command "Versetz" A1 P1 P2 "")
      (Setq E2 (Entlast))
      (Prompt "\nAuf welcher Seite soll ")
      (Princ (Rtos A2 2 4))
      (Setq P2 (Getpoint " abgetragen werden: "))
      (Command "Versetz" A2 P1 P2 "")
      (Setq E3 (Entlast))
    )
  )
  (If
    (Or (= B "2") (= B "A") (= B "M"))
      (Progn
        (Prompt "\nWas soll mit der Mittellinie geschehen?")
        (Initget "E L A M")
        (Setq A (Getkword "\nLschen/Erhalten/<Auf MITTEL>: "))
        (Cond
          ((= A "L")
            (Command "Lschen" "V" "")
          )
          ((Or (= A "A") (= A "M") (= A nil))
            (Command "NDERN" "V" "" "EI" "LA" "MITTEL" "")
          )
        )
      )
  )
  (Initget "J N")
  (Setq A (Getkword
    "\nRohre/Schienen sind Polylinien, in Linien aufbrechen? <J>: "))
  (If
    (Or (= A "J") (= A nil))
      (Command "Ursprung" E2 "Ursprung" E3 "Ursprung" E1 ^C)
  )
  (Princ)
  (SETVAR "CMDECHO" cmde)
)
;
;Grundrisslayer Ausschalten, Schnittlayer Einschalten
(DEFUN C:GASE ()
        (setq lay (tblsearch "layer" "skanten"))
        (setq layname (cdr (assoc 2 lay)))
     (if 
                (/= layname nil)
        (progn
       (COMMAND "LAYER" "SE" "0" "A" "KANTEN" "A" "VERDECKT" "A"
       "SCHMAL" "A" "MITTEL" "A" "HILFSLINIEN" "A" "SCHRAFFUR" "EI" "SKANTEN" "EI"
       "SVERDECKT" "EI" "SSCHMAL" "EI" "SMITTEL" "EI" "SSCHRAFFUR"
       "SE" "SKANTEN" "")
        ) ;progn
        (princ "\nKeine Schnittlayer vorhanden! ")
      )
(PRINC)
)
;Ende
;Schnittlayer Ausschalten, Grundrisslayer Einschalten
(DEFUN C:SAGE ()
         (COMMAND "LAYER" "SE" "0" "A" "SKANTEN" "A" "SVERDECKT" "A"
         "SSCHMAL" "A" "SMITTEL" "A" "SSCHRAFFUR" "EI" "HILFSLINIEN" "EI" "KANTEN" "EI"
         "VERDECKT" "EI" "SCHMAL" "EI" "MITTEL" "EI" "SCHRAFFUR" "SE" "KANTEN" "")
(PRINC)
)
;Ende
;
;
(DEFUN C:LIG ()   ; Lschen des Inhaltes der Grundrilayer u. Hilfslinien
;Schnittlayer Ausschalten, Grundrisslayer Einschalten
(COMMAND "LAYER" "SE" "0" "A" "SKANTEN" "A" "SVERDECKT" "A" "SSEIL" "A"
         "SSCHMAL" "A" "SMITTEL" "A" "SSCHRAFFUR" "EI" "KANTEN" "EI" "SEIL" "EI"
         "VERDECKT" "EI" "SCHMAL" "EI" "MITTEL" "EI" "SCHRAFFUR" "")
(PRINC)
;
(SETQ EP1(LIST 1000 1000))
(SETQ EP2(LIST 118000 830000))
(SETQ SKA(SSGET "F" EP1 EP2))
(COMMAND "LSCHEN" SKA "")
(PRINC)
;Grundrilayer Ausschalten, Schnittlayer Einschalten
(COMMAND "LAYER" "SE" "0" "A" "KANTEN" "A" "VERDECKT" "A" "SEIL" "A"
       "SCHMAL" "A" "MITTEL" "A" "SCHRAFFUR" "EI" "SKANTEN" "EI" "SSEIL" "EI"
       "SVERDECKT" "EI" "SSCHMAL" "EI" "SMITTEL" "EI" "SSCHRAFFUR" "")
(PRINC)
;
)
(DEFUN C:LIS ()   ; Lschen des Inhaltes der Schnittlayer u. Hilfslinien
;Grundrilayer Ausschalten, Schnittlayer Einschalten
(COMMAND "LAYER" "SE" "0" "A" "KANTEN" "A" "VERDECKT" "A" "SEIL" "A"
       "SCHMAL" "A" "MITTEL" "A" "SCHRAFFUR" "EI" "SKANTEN" "EI" "SSEIL" "EI"
       "SVERDECKT" "EI" "SSCHMAL" "EI" "SMITTEL" "EI" "SSCHRAFFUR" "")
(PRINC)
;
(SETQ EP1(LIST 1000 1000))
(SETQ EP2(LIST 118000 830000))
(SETQ SKA(SSGET "F" EP1 EP2))
(COMMAND "LSCHEN" SKA "")
(PRINC)
;Schnittlayer Ausschalten, Grundrisslayer Einschalten
(COMMAND "LAYER" "SE" "0" "A" "SKANTEN" "A" "SVERDECKT" "A" "SSEIL" "A"
         "SSCHMAL" "A" "SMITTEL" "A" "SSCHRAFFUR" "EI" "KANTEN" "EI" "SEIL" "EI"
         "VERDECKT" "EI" "SCHMAL" "EI" "MITTEL" "EI" "SCHRAFFUR" "")
(PRINC)
;
)
;
;
(DEFUN C:DS ()   ; Dreht die Schnittdarstellung um 90 Grad
(SETQ P1 (LIST 1000 3000))
(SETQ P2 (LIST 117000 80000))
(SETQ sf(SSGET "K" P1 P2))                
(SETQ pd(LIST 60000 40000))
(SETQ ps(LIST 60000 60000))
    (if
        (/= sf nil)
        (progn
(COMMAND "DREHEN" sf ""  pd 90) 
(COMMAND "SCHIEBEN"  "V" "" pd ps)
        )
        (princ "\nKeine Schnittobjekte vorhanden! ")
   )
(PRINC)
)
;
(DEFUN C:DSR () ; Dreht die Schnittdarstellung um 90 Grad zurck
(SETQ P1 (LIST 1000 3000))
(SETQ P2 (LIST 117000 80000))
(SETQ srf(SSGET "K" P1 P2))                
(SETQ pd(LIST 60000 40000))
(SETQ ps(LIST 60000 60000))
    (if
        (/= srf nil)
        (progn
(COMMAND "SCHIEBEN"  srf "" ps pd)
(COMMAND "DREHEN" "V" ""  pd -90) 
        )
        (princ "\nKeine Schnittobjekte vorhanden! ")
   )
(PRINC)
)
;
(defun C:BLOSE()        ;Blcke im Schnitt auf Bodenlinie schieben
(setq BL (car (entsel "\nBodenlinie anwhlen: ")))
(if 
        (/= BL nil)
        (progn
(setq SPBL (cdr (assoc 10 (entget BL))))
(setq YBL (cadr SPBL))
(setq BLO 1)
(While
        (/= BLO nil)
(setq BLO (car (entsel "\nAuf Bodenlinie zu setzenden Block anwhlen: ")))
        (if
                (/= BLO nil)
                (progn
(setq EIBLO (cdr (assoc 10 (entget BLO))))
(setq XEIBLO (car EIBLO))
(setq YEIBLO (cadr EIBLO))
(setq PO (list XEIBLO YBL))
(command "Schieben" BLO "" EIBLO PO )
                )
                (progn
                (princ "\nKeinen Block angewhlt! ")
                (princ)
                )
        )
);While
        );progn, if
        (progn
        (princ "\nKeine Bodenlinie gewhlt! ")
        (princ)
        )
)
(princ)
)
;Ende
;
(DEFUN C:ZE ()
(SETQ A (GETSTRING "\nGeben Sie den Zeichnungsnamen ein: "))
(SETQ F (OPEN "WECHSEL.SCR" "w"))
(WRITE-LINE "ENDE" F)
(WRITE-LINE "2" F)
(WRITE-LINE A F)
(CLOSE F)
(COMMAND "SCRIPT" "WECHSEL")
)
;
(DEFUN C:DEMO ()
(setvar "filedia" 0)
(Command "script" "dem")
(Princ)
(setvar "filedia" 1)
)
;

